
' Para executar este arquivo no Windows, basta fazer duplo clique no nome do arquivo.
' O resultado será exibido em forma de uma janela popup com o resultado (em formato json) da chamada

sUrl = "https://www.basebit.com.br/secure/tapi/account"
yourSignature = "sua assinatura eletrônica"
apiKey = "sua chave API com 32 caracteres alfanuméricos"
apiCode = "seu código API com 64 caracteres alfanuméricos"


tonce_BBT = DateDiff("s", "01/01/1970 00:00:00", now())
tonce_BBT = tonce_BBT + 3 * 60 * 60 ' Adiciona mais 3 horas já que o time é sempre em UTC

' toSign é String que será usada para o SHA512
toSign = sUrl & yourSignature & tonce_BBT

' strSignature é o resultado do hmac sha512
strSignature = hash_sha512(toSign, apiCode)

' Dados que serão postados na url indicada
sRequest = "key=" & apiKey & "&sign=" & strSignature

' Resultado do post
result = HTTPPost(sUrl, sRequest)

WScript.Echo("result=" & result)

' Função para fazer post em uma URL
Function HTTPPost(sUrl, sRequest)
  set oHTTP = CreateObject("Microsoft.XMLHTTP")
  oHTTP.open "POST", sUrl,false
  oHTTP.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
  oHTTP.setRequestHeader "Content-Length", Len(sRequest)
  oHTTP.send sRequest
  HTTPPost = oHTTP.responseText
 End Function

' Função que calcula o hmac sha512
Function hash_sha512( StringToHash, KeyForHash )

 Dim sha512,ObjUTF8, hmac
 Set ObjUTF8 = createobject("System.Text.UTF8Encoding")
 set sha512 = createobject("System.Security.Cryptography.HMACSHA512")

 sha512.Key = ObjUTF8.GetBytes_4( KeyForHash )

 hmac = sha512.ComputeHash_2( ObjUTF8.GetBytes_4( StringToHash ) )

 sha512.Clear()
 

 dim i, a, strText
  
 For i = 1 To LenB(hmac )
  a = a & Right("0" & Hex(AscB(MidB(hmac , i, 1))), 2)
 Next
 hash_sha512 = LCase(a)
  

End Function